/*
 * Rubber Spoon libSteg 0.4
 * DeSteg
 * by Joel R. Voss
 * August 16, 2004 10:55
 * SEE rs04.txt and rs04.c for more details.
 */

#include "rs04r.h"

// 4a) data byte -> data bits
// convertByteToBit converts one byte to a bit using the bit in the lowest 
// position. if the lowest bit is true, 1 << bit, else 0.
BYTE convertByteToBit(BYTE input, BYTE bit)
{
	// Bit must be between 0-7, else throw error.
	if(bit > 7) return 0;
	//printf("data = %x;\n", (input & 0x1));
	//printf("shda = %x;\n", (input & 0x1) << bit);
	return (input & 0x1) << bit;
}

// 4b) data bits -> data ints
// convertHexToBinary converts a byte to 8 bytes with each bit in the lowest 
// position of the byte it created.
BYTE convertBinaryToHex(BYTE *pixels)
{
	BYTE data = 0;
	int bit;
	//printf("data = %x;\n", data);
	for(bit = 7; bit >= 0; bit--)
	{
		data |= convertByteToBit(pixels[7-bit], bit);
		//printf("output1 = %x;\n", data);
	}
	return data;
}

// 4c) data bits -> data ints
// convertDataToBinary converts a N bytes to 8 * N bytes with each bit in the 
// lowest position of the byte it created.
void convertBinaryToData(BYTE *data, DWORD size, BYTE *dest)
{
	int index;
	//printf("data = %x;\n", data);
	for(index = 0; index < size; index++)
	{
		data[index] = convertBinaryToHex(&(dest[8*index]));
		//printf("output2 = %x;\n", data[index]);
	}
}


// desteg: A simple function to reverse the steg effect on pixels of an 
// image such that an onlooker will not see the data. <1>
void desteg(BYTE *data, DWORD size, BYTE *pixels)
{
	// 1) data bits -> data bytes
	convertBinaryToData(data, size, pixels);
}

#ifdef TEST

#include <stdio.h>

// Test libSteg desteg 0.4
int main(int argc, char *argv)
{
	int size = 17;
	BYTE data[size];
	BYTE pixels[size * 8];

	// Get the stegged image.
	fread(pixels, size * 8, 1, stdin);
	
	// The actual stegging.
	desteg(data, size, pixels);
	
	// Display the data
	printf("data: ");
	int index;
	for(index = 0; index < size; index++)
	{
		printf("%i ", data[index]);
	}
	printf("\n");
	for(index = 0; index < size; index++)
	{
		printf("%c", data[index]);
	}
	printf("\n");
	return 0;
}
#endif // TEST
