/*
 * Rubber Spoon libSteg 0.4
 * DeSteg
 * by Joel R. Voss
 * August 16, 2004 10:55
 * SEE rs04.txt and rs04.c for more details.
 */

#ifndef RS04R_H_

#define RS04R_H_

#include "types.h"

// 4a) data byte -> data bits
// convertByteToBit converts one byte to a bit using the bit in the lowest 
// position. if the lowest bit is true, 1 << bit, else 0.
BYTE convertByteToBit(BYTE input, BYTE bit);

// 4b) data bits -> data ints
// convertHexToBinary converts a byte to 8 bytes with each bit in the lowest 
// position of the byte it created.
BYTE convertBinaryToHex(BYTE *pixels);

// 4c) data bits -> data ints
// convertDataToBinary converts a N bytes to 8 * N bytes with each bit in the 
// lowest position of the byte it created.
void convertBinaryToData(BYTE *data, DWORD size, BYTE *dest);


// desteg: A simple function to reverse the steg effect on pixels of an 
// image such that an onlooker will not see the data. <1>
void desteg(BYTE *data, DWORD size, BYTE *pixels);

#endif // RS04R_H_
